diff --git a/reviewboard/hostingsvcs/beanstalk.py b/reviewboard/hostingsvcs/beanstalk.py
index fe813396c5def66d7b88ca2327f4c75b6d17b616..ffe8b09706070e1f60e7fed42644c234907127f9 100644
--- a/reviewboard/hostingsvcs/beanstalk.py
+++ b/reviewboard/hostingsvcs/beanstalk.py
@@ -1,3 +1,7 @@
+"""Hosting service for Beanstalk."""
+
+from __future__ import annotations
+
 import json
 import logging
 import os
@@ -10,8 +14,10 @@
 from django.urls import path
 from django.utils.translation import gettext_lazy as _
 from django.views.decorators.http import require_POST
+from housekeeping import deprecate_non_keyword_only_args
 
 from reviewboard.admin.server import get_server_url
+from reviewboard.deprecation import RemovedInReviewBoard90Warning
 from reviewboard.hostingsvcs.base.forms import (
     BaseHostingServiceAuthForm,
     BaseHostingServiceRepositoryForm,
@@ -252,22 +258,63 @@
              BeanstalkHookViews.process_post_receive_hook),
     ]
 
-    def check_repository(self, beanstalk_account_domain=None,
-                         beanstalk_repo_name=None, *args, **kwargs):
-        """Checks the validity of a repository.
+    @deprecate_non_keyword_only_args(RemovedInReviewBoard90Warning)
+    def check_repository(
+        self,
+        *,
+        beanstalk_account_domain: str,
+        beanstalk_repo_name: str,
+        **kwargs,
+    ) -> None:
+        """Check the validity of a repository.
 
         This will perform an API request against Beanstalk to get
         information on the repository. This will throw an exception if
         the repository was not found, and return cleanly if it was found.
+
+        Version Changed:
+            7.1:
+            Made arguments keyword-only.
+
+        Args:
+            beanstalk_account_domain (str):
+                The domain for the Beanstalk account.
+
+            beanstalk_repo_name (str):
+                The name of the repository.
+
+            **kwargs (dict, unused):
+                Additional information passed by the repository form.
         """
         self._api_get_repository(beanstalk_account_domain, beanstalk_repo_name)
 
-    def authorize(self, username, password, hosting_url,
-                  local_site_name=None, *args, **kwargs):
-        """Authorizes the Beanstalk repository.
+    @deprecate_non_keyword_only_args(RemovedInReviewBoard90Warning)
+    def authorize(
+        self,
+        *,
+        username: str | None,
+        password: str | None,
+        **kwargs,
+    ) -> None:
+        """Authorize the Beanstalk repository.
 
         Beanstalk uses HTTP Basic Auth for the API, so this will store the
         provided password, encrypted, for use in later API requests.
+
+        Version Changed:
+            7.1:
+            Made arguments keyword-only.
+
+        Args:
+            username (str):
+                The username for the account.
+
+            password (str):
+                The password for the account.
+
+            **kwargs (dict, unused):
+                Extra keyword arguments containing values from the
+                repository's configuration.
         """
         self.account.data['password'] = encrypt_password(password)
         self.account.save()
diff --git a/reviewboard/hostingsvcs/bitbucket.py b/reviewboard/hostingsvcs/bitbucket.py
index cb0a984b5000bad74b5d8d220f3a8d702eb2976a..f0ed0a602df5e60a24ed9dd24d813880db124993 100644
--- a/reviewboard/hostingsvcs/bitbucket.py
+++ b/reviewboard/hostingsvcs/bitbucket.py
@@ -1,3 +1,7 @@
+"""Hosting service for Bitbucket."""
+
+from __future__ import annotations
+
 import json
 import logging
 from collections import defaultdict
@@ -13,8 +17,10 @@
 from django.urls import path
 from django.utils.translation import gettext_lazy as _, gettext
 from django.views.decorators.http import require_POST
+from housekeeping import deprecate_non_keyword_only_args
 
 from reviewboard.admin.server import build_server_url, get_server_url
+from reviewboard.deprecation import RemovedInReviewBoard90Warning
 from reviewboard.hostingsvcs.base.forms import (
     BaseHostingServiceAuthForm,
     BaseHostingServiceRepositoryForm,
@@ -936,8 +942,14 @@
 
     DEFAULT_PLAN = 'personal'
 
-    def check_repository(self, plan=DEFAULT_PLAN, tool_name=None,
-                         *args, **kwargs):
+    @deprecate_non_keyword_only_args(RemovedInReviewBoard90Warning)
+    def check_repository(
+        self,
+        *,
+        plan: str = DEFAULT_PLAN,
+        tool_name: (str | None) = None,
+        **kwargs,
+    ) -> None:
         """Check the validity of a repository configuration.
 
         This will ensure that the configuration data being provided by the
@@ -949,17 +961,18 @@
         the repository was not found, or does not match the expected
         repository type, and return cleanly if it was found.
 
+        Version Changed:
+            7.1:
+            Made arguments keyword-only.
+
         Args:
-            plan (unicode, optional):
+            plan (str, optional):
                 The configured repository plan.
 
-            tool_name (unicode, optional):
+            tool_name (str, optional):
                 The name of the tool selected to communicate with the
                 repository.
 
-            *args (tuple, unused):
-                Unused positional arguments.
-
             **kwargs (dict, unused):
                 Additional information passed by the repository form.
 
@@ -1001,7 +1014,14 @@
                 gettext('The Bitbucket repository being configured does not '
                         'match the type of repository you have selected.'))
 
-    def authorize(self, username, password, *args, **kwargs):
+    @deprecate_non_keyword_only_args(RemovedInReviewBoard90Warning)
+    def authorize(
+        self,
+        *,
+        username: str | None,
+        password: str | None,
+        **kwargs,
+    ) -> None:
         """Authorize an account on Bitbucket.
 
         This will attempt to access the user session resource using the
@@ -1014,16 +1034,17 @@
 
         If successful, the password is stored in an encrypted form.
 
+        Version Changed:
+            7.1:
+            Made arguments keyword-only.
+
         Args:
-            username (unicode):
+            username (str):
                 The username for the account.
 
-            password (unicode):
+            password (str):
                 The user's password or app password.
 
-            *args (tuple, unused):
-                Unused positional arguments.
-
             **kwargs (dict, unused):
                 Unused keyword arguments.
 
diff --git a/reviewboard/hostingsvcs/codebasehq.py b/reviewboard/hostingsvcs/codebasehq.py
index 4e38085a3e0f632b839aa2d7b154b9dbbe578003..7b3e5fe3b062822ab340961f9e5f088b053e5c72 100644
--- a/reviewboard/hostingsvcs/codebasehq.py
+++ b/reviewboard/hostingsvcs/codebasehq.py
@@ -1,10 +1,17 @@
+"""Hosting service for CodebaseHQ."""
+
+from __future__ import annotations
+
 import logging
+from typing import TYPE_CHECKING
 from urllib.error import HTTPError, URLError
 from xml.dom.minidom import parseString
 
 from django import forms
 from django.utils.translation import gettext_lazy as _, gettext
+from housekeeping import deprecate_non_keyword_only_args
 
+from reviewboard.deprecation import RemovedInReviewBoard90Warning
 from reviewboard.hostingsvcs.base.client import HostingServiceClient
 from reviewboard.hostingsvcs.base.forms import (
     BaseHostingServiceAuthForm,
@@ -18,6 +25,10 @@
                                                encrypt_password)
 from reviewboard.scmtools.errors import FileNotFoundError
 
+if TYPE_CHECKING:
+    from reviewboard.hostingsvcs.base.hosting_service import \
+        HostingServiceCredentials
+
 
 logger = logging.getLogger(__name__)
 
@@ -388,7 +399,15 @@
 
         self.client = CodebaseHQClient(self)
 
-    def authorize(self, username, password, credentials, *args, **kwargs):
+    @deprecate_non_keyword_only_args(RemovedInReviewBoard90Warning)
+    def authorize(
+        self,
+        *,
+        username: str | None,
+        password: str | None,
+        credentials: HostingServiceCredentials,
+        **kwargs,
+    ) -> None:
         """Authorize an account for Codebase.
 
         Codebase uses HTTP Basic Auth with an API username (consisting of the
@@ -396,20 +415,21 @@
         the password) for API calls, and a standard username/password for
         Subversion repository access. We need to store all of this.
 
+        Version Changed:
+            7.1:
+            Made arguments keyword-only.
+
         Args:
-            username (unicode):
+            username (str):
                 The username to authorize.
 
-            password (unicode):
+            password (str):
                 The API token used as a password.
 
             credentials (dict):
                 Additional credentials from the authentication form.
 
-            *args (tuple):
-                Extra unused positional arguments.
-
-            **kwargs (dict):
+            **kwargs (dict, unused):
                 Extra unused keyword arguments.
 
         Raises:
@@ -466,30 +486,37 @@
         """
         return decrypt_password(self.account.data['password'])
 
-    def check_repository(self, codebasehq_project_name=None,
-                         codebasehq_repo_name=None, tool_name=None,
-                         *args, **kwargs):
+    @deprecate_non_keyword_only_args(RemovedInReviewBoard90Warning)
+    def check_repository(
+        self,
+        *,
+        codebasehq_project_name: (str | None) = None,
+        codebasehq_repo_name: (str | None) = None,
+        tool_name: (str | None) = None,
+        **kwargs,
+    ) -> None:
         """Check the validity of a repository.
 
         This will perform an API request against Codebase to get information on
         the repository. This will throw an exception if the repository was not
         found, and return cleanly if it was found.
 
+        Version Changed:
+            7.1:
+            Made arguments keyword-only.
+
         Args:
-            codebase_project_name (unicode):
+            codebasehq_project_name (str):
                 The name of the project on Codebase.
 
-            codebasehq_repo_name (unicode):
+            codebasehq_repo_name (str):
                 The name of the repository on Codebase.
 
-            tool_name (unicode):
+            tool_name (str):
                 The name of the SCMTool for the repository.
 
-            *args (tuple):
-                Extra unused positional arguments passed to this function.
-
-            **kwargs (dict):
-                Extra unused keyword arguments passed to this function.
+            **kwargs (dict, unused):
+                Additional keyword arguments passed by the repository form.
 
         Raises:
             reviewboard.hostingsvcs.errors.RepositoryError:
diff --git a/reviewboard/hostingsvcs/errors.py b/reviewboard/hostingsvcs/errors.py
index 12dcc0204e857a0e75e39c404cd0825c0ffb083a..943a7b5714225db3287d41ae9e8af2198ad9a6e9 100644
--- a/reviewboard/hostingsvcs/errors.py
+++ b/reviewboard/hostingsvcs/errors.py
@@ -79,16 +79,16 @@
     ######################
 
     #: The HTTP status code for the error, if available.
-    http_code: Optional[int]
+    http_code: int | None
 
     #: The parsed payload for the error, if available.
-    rsp: Optional[Dict]
+    rsp: object | None
 
     def __init__(
         self,
-        msg: Optional[str] = None,
-        http_code: Optional[int] = None,
-        rsp: Optional[Dict] = None,
+        msg: (str | None) = None,
+        http_code: (int | None) = None,
+        rsp: (object | None) = None,
     ) -> None:
         """Initialize the error.
 
diff --git a/reviewboard/hostingsvcs/gerrit.py b/reviewboard/hostingsvcs/gerrit.py
index cd10a524b0a8fa48f8234aee2b641d1474be9b60..da64296f853676e49bcaeb215576ce734f9d3c0f 100644
--- a/reviewboard/hostingsvcs/gerrit.py
+++ b/reviewboard/hostingsvcs/gerrit.py
@@ -1,15 +1,20 @@
 """Gerrit source code hosting support."""
 
+from __future__ import annotations
+
 import base64
 import json
 import logging
+from typing import TYPE_CHECKING
 from urllib.error import HTTPError, URLError
 from urllib.parse import quote_plus, urljoin, urlparse
 
 from django import forms
 from django.utils.translation import gettext, gettext_lazy as _
 from djblets.util.decorators import cached_property
+from housekeeping import deprecate_non_keyword_only_args
 
+from reviewboard.deprecation import RemovedInReviewBoard90Warning
 from reviewboard.hostingsvcs.base.client import HostingServiceClient
 from reviewboard.hostingsvcs.base.forms import (
     BaseHostingServiceAuthForm,
@@ -26,6 +31,10 @@
                                                encrypt_password)
 from reviewboard.scmtools.errors import FileNotFoundError
 
+if TYPE_CHECKING:
+    from reviewboard.hostingsvcs.base.hosting_service import \
+        HostingServiceCredentials
+
 
 logger = logging.getLogger(__name__)
 
@@ -288,26 +297,33 @@
         },
     }
 
-    def check_repository(self, gerrit_url=None, gerrit_project_name=None,
-                         *args, **kwargs):
+    @deprecate_non_keyword_only_args(RemovedInReviewBoard90Warning)
+    def check_repository(
+        self,
+        *,
+        gerrit_url: str,
+        gerrit_project_name: str,
+        **kwargs,
+    ) -> None:
         """Check that the repository is configured correctly.
 
         This method ensures that the user has access to an existing repository
         on the Gerrit server and that the ``gerrit-reviewboard`` plugin is
         installed and of a compatible version.
 
+        Version Changed:
+            7.1:
+            Made arguments keyword-only.
+
         Args:
-            gerrit_url (unicode):
+            gerrit_url (str):
                 The URL to the Gerrit server.
 
-            gerrit_project_name (unicode):
+            gerrit_project_name (str):
                 The repository's configured project name on Gerrit.
 
-            *args (tuple):
-                Ignored positional arguments.
-
-            **kwargs (dict):
-                Ignored keyword arguments.
+            **kwargs (dict, unused):
+                Additional keyword arguments passed by the repository form.
 
         Raises:
             reviewboard.hostingsvcs.errors.RepositoryError:
@@ -386,31 +402,41 @@
                     }
                 )
 
-    def authorize(self, username, password, credentials,
-                  local_site_name=None, gerrit_url=None, *args, **kwargs):
+    @deprecate_non_keyword_only_args(RemovedInReviewBoard90Warning)
+    def authorize(
+        self,
+        *,
+        username: str | None,
+        password: str | None,
+        credentials: HostingServiceCredentials,
+        local_site_name: (str | None) = None,
+        gerrit_url: str,
+        **kwargs,
+    ) -> None:
         """Authorize against the Gerrit server.
 
+        Version Changed:
+            7.1:
+            Made arguments keyword-only.
+
         Args:
-            username (unicode):
+            username (str):
                 The username to use for authentication.
 
-            password  unicode):
+            password (str):
                 The password to use for authentication.
 
             credentials (dict):
                 The credentials from the authentication form.
 
-            local_site_name (unicode, optional):
+            local_site_name (str, optional):
                 The name of the :py:class:`~reviewboard.site.models.LocalSite`
                 the repository is associated with.
 
-            gerrit_url (unicode):
+            gerrit_url (str):
                 The URL of the Gerrit server.
 
-            *args (tuple):
-                Ignored positional arguments.
-
-            **kwargs (dict):
+            **kwargs (dict, unused):
                 Ignored keyword arguments.
 
         Raises:
diff --git a/reviewboard/hostingsvcs/github.py b/reviewboard/hostingsvcs/github.py
index 11071143b2f34ea4e01f40e59aede350f1d651d4..204763e207f609780a5474dfd3266d65103531fc 100644
--- a/reviewboard/hostingsvcs/github.py
+++ b/reviewboard/hostingsvcs/github.py
@@ -19,8 +19,10 @@
 from django.urls import path
 from django.utils.translation import gettext, gettext_lazy as _
 from django.views.decorators.http import require_POST
+from housekeeping import deprecate_non_keyword_only_args
 
 from reviewboard.admin.server import build_server_url, get_server_url
+from reviewboard.deprecation import RemovedInReviewBoard90Warning
 from reviewboard.hostingsvcs.base.bug_tracker import BaseBugTracker
 from reviewboard.hostingsvcs.base.client import HostingServiceClient
 from reviewboard.hostingsvcs.base.hosting_service import BaseHostingService
@@ -724,12 +726,33 @@
                             name)
         return plan_data[key]
 
-    def check_repository(self, plan=None, *args, **kwargs):
-        """Checks the validity of a repository.
+    @deprecate_non_keyword_only_args(RemovedInReviewBoard90Warning)
+    def check_repository(
+        self,
+        *,
+        plan: str,
+        **kwargs,
+    ) -> None:
+        """Check the validity of a repository.
 
         This will perform an API request against GitHub to get
         information on the repository. This will throw an exception if
         the repository was not found, and return cleanly if it was found.
+
+        Version Changed:
+            7.1:
+            Made arguments keyword-only.
+
+        Args:
+            plan (str):
+                The ID of the plan that the repository is on.
+
+            **kwargs (dict, unused):
+                Additional keyword arguments passed by the repository form.
+
+        Raises:
+            reviewboard.hostingsvcs.errors.RepositoryError:
+                The repository is not valid.
         """
         try:
             rsp = self.client.http_get(
@@ -739,7 +762,7 @@
             repo_info = rsp.json
         except HostingServiceError as e:
             if e.http_code == 404:
-                if plan in ('public', 'private'):
+                if plan in {'public', 'private'}:
                     raise RepositoryError(
                         gettext('A repository with this name was not found, '
                                 'or your user may not own it.'))
@@ -761,37 +784,46 @@
         if 'private' in repo_info:
             is_private = repo_info['private']
 
-            if is_private and plan in ('public', 'public-org'):
+            if is_private and plan in {'public', 'public-org'}:
                 raise RepositoryError(
                     gettext('This is a private repository, but you have '
                             'selected a public plan.'))
-            elif not is_private and plan in ('private', 'private-org'):
+            elif not is_private and plan in {'private', 'private-org'}:
                 raise RepositoryError(
                     gettext('This is a public repository, but you have '
                             'selected a private plan.'))
 
-    def authorize(self, username, password, hosting_url=None,
-                  local_site_name=None, *args, **kwargs):
+    @deprecate_non_keyword_only_args(RemovedInReviewBoard90Warning)
+    def authorize(
+        self,
+        *,
+        username: str | None,
+        password: str | None,
+        hosting_url: (str | None) = None,
+        local_site_name: (str | None) = None,
+        **kwargs,
+    ) -> None:
         """Authorize an account for the hosting service.
 
+        Version Changed:
+            7.1:
+            Made arguments keyword-only.
+
         Args:
-            username (unicode):
+            username (str):
                 The username for the account.
 
-            password (unicode):
+            password (str):
                 The Personal Access Token for the account.
 
-            hosting_url (unicode):
+            hosting_url (str, optional):
                 The hosting URL for the service, if self-hosted.
 
-            local_site_name (unicode, optional):
+            local_site_name (str, optional):
                 The Local Site name, if any, that the account should be
                 bound to.
 
-            *args (tuple):
-                Extra unused positional arguments.
-
-            **kwargs (dict):
+            **kwargs (dict, unused):
                 Extra keyword arguments containing values from the
                 repository's configuration.
 
diff --git a/reviewboard/hostingsvcs/gitlab.py b/reviewboard/hostingsvcs/gitlab.py
index 31dffbfbc0055cad9db8cb8c85cce4ffe27135e6..642909a4f5067a7ab00d21ae423300a90f295d76 100644
--- a/reviewboard/hostingsvcs/gitlab.py
+++ b/reviewboard/hostingsvcs/gitlab.py
@@ -1,5 +1,10 @@
+"""Hosting service for GitLab."""
+
+from __future__ import annotations
+
 import logging
 import re
+from typing import TYPE_CHECKING
 from urllib.error import HTTPError, URLError
 from urllib.parse import quote, quote_plus, urlparse
 
@@ -10,8 +15,10 @@
 from django.utils.encoding import force_str
 from django.utils.translation import gettext, gettext_lazy as _
 from djblets.cache.backend import cache_memoize
+from housekeeping import deprecate_non_keyword_only_args
 
 from reviewboard.admin.support import get_kb_url
+from reviewboard.deprecation import RemovedInReviewBoard90Warning
 from reviewboard.hostingsvcs.base.forms import (
     BaseHostingServiceAuthForm,
     BaseHostingServiceRepositoryForm,
@@ -26,6 +33,10 @@
 from reviewboard.scmtools.errors import FileNotFoundError
 from reviewboard.scmtools.core import Branch, Commit
 
+if TYPE_CHECKING:
+    from reviewboard.hostingsvcs.base.hosting_service import \
+        HostingServiceCredentials
+
 
 logger = logging.getLogger(__name__)
 
@@ -296,37 +307,67 @@
         }),
     ]
 
-    def check_repository(self, plan=None, *args, **kwargs):
-        """Checks the validity of a repository.
+    @deprecate_non_keyword_only_args(RemovedInReviewBoard90Warning)
+    def check_repository(
+        self,
+        *,
+        plan: str,
+        **kwargs,
+    ) -> None:
+        """Check the validity of a repository.
 
         This will perform an API request against GitLab to get
         information on the repository. This will throw an exception if
         the repository was not found, and return cleanly if it was found.
+
+        Version Changed:
+            7.1:
+            Made arguments keyword-only.
+
+        Args:
+            plan (str):
+                The ID of the plan that the repository is on.
+
+            **kwargs (dict, unused):
+                Additional keyword arguments passed by the repository form.
+
+        Raises:
+            reviewboard.hostingsvcs.errors.RepositoryError:
+                The repository is not valid.
         """
         self._find_repository_id(
             plan,
             self._get_repository_owner(plan, kwargs),
             self._get_repository_name(plan, kwargs))
 
-    def authorize(self, username, credentials, hosting_url, *args, **kwargs):
+    @deprecate_non_keyword_only_args(RemovedInReviewBoard90Warning)
+    def authorize(
+        self,
+        *,
+        username: str | None,
+        credentials: HostingServiceCredentials,
+        hosting_url: str | None,
+        **kwargs,
+    ) -> None:
         """Authorize the GitLab repository.
 
         GitLab uses HTTP Basic Auth for the API, so this will store the
         provided password, encrypted, for use in later API requests.
 
+        Version Changed:
+            7.1:
+            Made arguments keyword-only.
+
         Args:
-            username (unicode):
+            username (str):
                 The username of the account being linked.
 
             credentials (dict):
                 Authentication credentials.
 
-            hosting_url (unicode):
+            hosting_url (str):
                 The URL of the GitLab server.
 
-            *args (tuple, unused):
-                Ignored positional arguments.
-
             **kwargs (dict, unused):
                 Ignored keyword arguments.
 
diff --git a/reviewboard/hostingsvcs/kiln.py b/reviewboard/hostingsvcs/kiln.py
index 0e09f4116e6dca7c8b08d9349488dc3e3a3f9cb8..019147a1fd5d1a7c2fca81b8686bb2d19d4c956c 100644
--- a/reviewboard/hostingsvcs/kiln.py
+++ b/reviewboard/hostingsvcs/kiln.py
@@ -1,10 +1,16 @@
+"""Hosting service for Kiln."""
+
+from __future__ import annotations
+
 import binascii
 import json
 from urllib.error import HTTPError, URLError
 
 from django import forms
 from django.utils.translation import gettext, gettext_lazy as _
+from housekeeping import deprecate_non_keyword_only_args
 
+from reviewboard.deprecation import RemovedInReviewBoard90Warning
 from reviewboard.hostingsvcs.base.client import HostingServiceClient
 from reviewboard.hostingsvcs.base.forms import BaseHostingServiceRepositoryForm
 from reviewboard.hostingsvcs.base.hosting_service import BaseHostingService
@@ -219,14 +225,45 @@
         },
     }
 
-    def check_repository(self, kiln_account_domain=None,
-                         kiln_project_name=None, kiln_group_name=None,
-                         kiln_repo_name=None, *args, **kwargs):
-        """Checks the validity of a repository.
+    @deprecate_non_keyword_only_args(RemovedInReviewBoard90Warning)
+    def check_repository(
+        self,
+        *,
+        kiln_account_domain: str,
+        kiln_project_name: str,
+        kiln_group_name: str,
+        kiln_repo_name: str,
+        **kwargs,
+    ) -> None:
+        """Check the validity of a repository.
 
         This will check to see if there's a repository accessible to the
         user matching the provided information. This will throw an exception
         if the repository was not found, and return cleanly if it was found.
+
+        Version Changed:
+            7.1:
+            Made arguments keyword-only.
+
+        Args:
+            kiln_account_domain (str):
+                The domain for the user's Kiln account.
+
+            kiln_project_name (str):
+                The name of the project.
+
+            kiln_group_name (str):
+                The name of the group within the project.
+
+            kiln_repo_name (str):
+                The name of the repository.
+
+            **kwargs (dict, unused):
+                Additional keyword arguments provided by the repository form.
+
+        Raises:
+            reviewboard.hostingsvcs.errors.RepositoryError:
+                The repository is not valid.
         """
         repo_info = self._find_repository_info(kiln_project_name,
                                                kiln_group_name,
@@ -238,14 +275,38 @@
                 'found. Please verify that the information exactly matches '
                 'the configuration on Kiln.'))
 
-    def authorize(self, username, password, kiln_account_domain,
-                  *args, **kwargs):
-        """Authorizes the Kiln repository.
+    @deprecate_non_keyword_only_args(RemovedInReviewBoard90Warning)
+    def authorize(
+        self,
+        *,
+        username: str | None,
+        password: str | None,
+        kiln_account_domain: str,
+        **kwargs,
+    ) -> None:
+        """Authorize the Kiln repository.
 
         Kiln requires an authentication request against a login URL,
         and will return an API token on success. This token is stored
         along with the account data. The username and password are not
         stored.
+
+        Version Changed:
+            7.1:
+            Made arguments keyword-only.
+
+        Args:
+            username (str):
+                The username for the account.
+
+            password (str):
+                The password for the account.
+
+            kiln_account_domain (str):
+                The domain for the user's Kiln account.
+
+            **kwargs (dict, unused):
+                Unused keyword arguments.
         """
         self.account.data['kiln_account_domain'] = kiln_account_domain
 
diff --git a/reviewboard/hostingsvcs/rbgateway.py b/reviewboard/hostingsvcs/rbgateway.py
index ce5fa630cf6bd79e503da784bcd4820ab63fa11a..7a8208ce921f2fb5dc8e2bfc1c72e98353c006de 100644
--- a/reviewboard/hostingsvcs/rbgateway.py
+++ b/reviewboard/hostingsvcs/rbgateway.py
@@ -1,3 +1,7 @@
+"""Hosting service for Review Board Gateway."""
+
+from __future__ import annotations
+
 import hashlib
 import hmac
 import json
@@ -11,8 +15,10 @@
 from django.template.loader import render_to_string
 from django.urls import path
 from django.utils.translation import gettext_lazy as _, gettext
+from housekeeping import deprecate_non_keyword_only_args
 
 from reviewboard.admin.server import build_server_url, get_server_url
+from reviewboard.deprecation import RemovedInReviewBoard90Warning
 from reviewboard.hostingsvcs.base.client import HostingServiceClient
 from reviewboard.hostingsvcs.base.forms import BaseHostingServiceRepositoryForm
 from reviewboard.hostingsvcs.base.hosting_service import BaseHostingService
@@ -638,18 +644,21 @@
              name='rbgateway-hooks-close-submitted'),
     ]
 
-    def check_repository(self, rbgateway_repo_name, *args, **kwargs):
+    @deprecate_non_keyword_only_args(RemovedInReviewBoard90Warning)
+    def check_repository(
+        self,
+        *,
+        rbgateway_repo_name: str,
+        **kwargs,
+    ) -> None:
         """Checks the validity of a repository configuration.
 
         Args:
-            rbgateway_repo_name (unicode):
+            rbgateway_repo_name (str):
                 The name of the repository to check.
 
-            *args (tuple, unused):
-                Unused positional arguments.
-
             **kwargs (dict, unused):
-                Unused dictionary arguments.
+                Additional keyword arguments provided by the repository form.
 
         Raises:
             reviewboard.hostingsvcs.errors.RepositoryError:
@@ -666,23 +675,31 @@
 
             raise
 
-    def authorize(self, username, password, *args, **kwargs):
+    @deprecate_non_keyword_only_args(RemovedInReviewBoard90Warning)
+    def authorize(
+        self,
+        *,
+        username: str | None,
+        password: str | None,
+        **kwargs,
+    ) -> None:
         """Authorize an account on the RB Gateway service.
 
         This will perform an authentication request against the API. If
         successful, the generated API token will be stored, encrypted, for
         future requests to the API.
 
+        Version Changed:
+            7.1:
+            Made arguments keyword-only.
+
         Args:
-            username (unicode):
+            username (str):
                 The username for the account.
 
-            password (unicode):
+            password (str):
                 The password for the account.
 
-            *args (tuple, unused):
-                Unused positional arguments.
-
             **kwargs (dict, unused):
                 Unused keyword arguments.
 
